/// <reference path="../types/react.d.ts" />
import * as babel from '@babel/core';
/**
 * Mutatively(!) process an AST
 *
 * @param ast A babel AST
 */
export declare function preprocessAst(ast: babel.types.Node): void;
export declare type PreprocessOptions = {
    /** The path of the file being transformed. **This is needed if using source maps** */
    filename?: string;
};
/**
 * Accept source code and process it
 */
export declare function preprocess(code: string, { filename }?: PreprocessOptions): Promise<babel.BabelFileResult | undefined>;
